EXEC = clang
TARGET = -target
TYPE = rl78
AR = llvm-ar
CC := $(EXEC) $(TARGET) $(TYPE)
RANLIB = llvm-ranlib
CCOPTS = -I'$(SRCDIR)/../newlib/libc/include' -O2 -fomit-frame-pointer -fdata-sections -ffunction-sections -mmirror-source-common -D__ELF__ -Wall -Wno-unused-parameter -O3 -DNDEBUG    -fno-lto -std=c11 -fPIC -fno-builtin -fvisibility=hidden
ASOPTS = -frenesas-extensions
FLAGS1 = -DVISIBILITY_HIDDEN
INC = -I '$(SRCDIR)/'
AR_SW = -rcus
LIBPATH ?= ./libcompilerrt.a
CCUOPTS = 
ASUOPTS = 

SUB = S3


ifeq (-mcpu=s1,$(findstring -mcpu=s1,$(CCUOPTS)))
SUB = S1_S2
else
ifeq (-mcpu=s2,$(findstring -mcpu=s2,$(CCUOPTS)))
SUB = S1_S2
else
ifeq (-mcpu=s3,$(findstring -mcpu=s3,$(CCUOPTS)))
SUB = S3
endif
endif
endif

ifeq (-mcpu=S1,$(findstring -mcpu=S1,$(CCUOPTS)))
SUB = S1_S2
else
ifeq (-mcpu=S2,$(findstring -mcpu=S2,$(CCUOPTS)))
SUB = S1_S2
else
ifeq (-mcpu=S3,$(findstring -mcpu=S3,$(CCUOPTS)))
SUB = S3
endif
endif
endif

rl78:    COM_scdiv.S.obj \
 COM_ucdiv.S.obj \
 COM_divul.S.obj \
 COM_divui.S.obj \
 COM_mulsi.S.obj \
 COM_mulsl.S.obj \
 COM_mulul.S.obj \
 COM_mului.S.obj \
 COM_lshl.S.obj \
 COM_lshr.S.obj \
 COM_lsar.S.obj \
 COM_llsar.S.obj \
 COM_llshl.S.obj \
 COM_llshr.S.obj \
 COM_ftosl.S.obj \
 COM_dtosl.S.obj \
 COM_ftosll.S.obj \
 REL_dtol.S.obj \
 REL_ftol.S.obj \
 REL_ftoll.S.obj \
 REL_lltosll.S.obj \
 REL_ltosl.S.obj \
 REL_llrev.S.obj \
 COM_dtoul.S.obj \
 COM_ftoull.S.obj \
 COM_ftoul.S.obj \
 COM_slltof.S.obj \
 COM_sltod.S.obj \
 COM_sltof.S.obj \
 REL_lltof.S.obj \
 REL_ltod.S.obj \
 REL_ltof.S.obj \
 REL_setexp_ll.S.obj \
 COM_slltod.S.obj \
 COM_ulltof.S.obj \
 COM_ultod.S.obj \
 COM_ultof.S.obj \
 REL_d_round.S.obj \
 REL_lltod.S.obj \
 COM_dtosll.S.obj \
 COM_dtoull.S.obj \
 COM_ulltod.S.obj \
 REL_dtoll.S.obj \
 COM_ftod.S.obj \
 COM_fdiv.S.obj \
 REL_f_inf.S.obj \
 REL_f_norm.S.obj \
 REL_f_round.S.obj \
 COM_fmul.S.obj \
 COM_faddsub.S.obj \
 COM_dadd.S.obj \
 REL_d_inf.S.obj \
 REL_d_check.S.obj \
 REL_d_shl11.S.obj \
 COM_ddiv.S.obj \
 COM_dmul.S.obj \
 COM_dsub.S.obj \
 COM_dtof.S.obj \
 COM_uldiv.S.obj \
 COM_ulldiv.S.obj \
 REL_lldiv.S.obj \
 COM_ulrem.S.obj \
 COM_ullrem.S.obj \
 REL_llrem.S.obj \
 COM_slrem.S.obj \
 COM_sllrem.S.obj \
 COM_llmul.S.obj \
 REL_llmul_addh.S.obj \
 COM_macsi.S.obj \
 COM_macui.S.obj \
 COM_screm.S.obj \
 COM_ucrem.S.obj \
 COM_remui.S.obj \
 COM_remul.S.obj \
 COM_uirem.S.obj \
 COM_sirem.S.obj \
 COM_imul.S.obj \
 COM_lmul.S.obj \
 ashlhi3.S.obj \
 ashlqi3.S.obj \
 ashrhi3.S.obj \
 ashrqi3.S.obj \
 hi_min_max.c.obj \
 lshrhi3.S.obj \
 lshrqi3.S.obj \
 rotlhi3.S.obj \
 rotlqi3.S.obj \
 rotrhi3.S.obj \
 rotrqi3.S.obj \
 COM_deq.S.obj \
 COM_dge.S.obj \
 COM_dgt.S.obj \
 COM_dle.S.obj \
 COM_dlt.S.obj \
 COM_dne.S.obj \
 COM_dunordered.S.obj \
 COM_feq.S.obj \
 COM_fge.S.obj \
 COM_fgt.S.obj \
 COM_fle.S.obj \
 COM_flt.S.obj \
 COM_fne.S.obj \
 COM_funordered.S.obj \
 REL_dcmp.S.obj \
 REL_dordered_core.S.obj \
 REL_fcmp.S.obj \
 REL_fordered_core.S.obj \
 COM_slldiv.S.obj \
 COM_sidiv.S.obj \
 COM_uidiv.S.obj \
 COM_sldiv.S.obj
 
all:  absvdi2.c.obj \
 absvsi2.c.obj \
 addvdi3.c.obj \
 addvsi3.c.obj \
 andsi3.c.obj \
 bswapdi2.c.obj \
 bswapsi2.c.obj \
 clzdi2.c.obj \
 clzsi2.c.obj \
 cmpdi2.c.obj \
 comparedf2.c.obj \
 comparesf2.c.obj \
 ctzdi2.c.obj \
 ctzsi2.c.obj \
 divdc3.c.obj \
 divmoddi4.c.obj \
 divmodsi4.c.obj \
 divsc3.c.obj \
 extendhfsf2.c.obj \
 ffsdi2.c.obj \
 ffssi2.c.obj \
 floattidf.c.obj \
 floattisf.c.obj \
 floatuntidf.c.obj \
 floatuntisf.c.obj \
 fp_mode.c.obj \
 int_util.c.obj \
 muldc3.c.obj \
 mulodi4.c.obj \
 mulosi4.c.obj \
 mulsc3.c.obj \
 mulvdi3.c.obj \
 mulvsi3.c.obj \
 negdf2.c.obj \
 negdi2.c.obj \
 negsf2.c.obj \
 negvdi2.c.obj \
 negvsi2.c.obj \
 paritydi2.c.obj \
 paritysi2.c.obj \
 popcountdi2.c.obj \
 popcountsi2.c.obj \
 powidf2.c.obj \
 powisf2.c.obj \
 subvdi3.c.obj \
 subvsi3.c.obj \
 trampoline_setup.c.obj \
 truncdfhf2.c.obj \
 truncsfhf2.c.obj \
 ucmpdi2.c.obj \
 udivmoddi4.c.obj \
 udivmodsi4.c.obj 
 
clean:
	-@$(RM) *.o

%.o: %.S
	
absvdi2.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/absvdi2.c' $(CCUOPTS) $(ASUOPTS) $(INC)

absvsi2.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/absvsi2.c' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_dadd.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_dadd.S' $(CCUOPTS) $(ASUOPTS) $(INC)

REL_d_inf.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/REL_d_inf.S' $(CCUOPTS) $(ASUOPTS) $(INC)

REL_d_check.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/REL_d_check.S' $(CCUOPTS) $(ASUOPTS) $(INC)

REL_d_shl11.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/REL_d_shl11.S' $(CCUOPTS) $(ASUOPTS) $(INC)


COM_faddsub.S.obj:
	 @$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_faddsub.S' $(CCUOPTS) $(ASUOPTS) $(INC)

addvdi3.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/addvdi3.c' $(CCUOPTS) $(ASUOPTS) $(INC)

addvsi3.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/addvsi3.c' $(CCUOPTS) $(ASUOPTS) $(INC)

andsi3.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/andsi3.c' $(CCUOPTS) $(ASUOPTS) $(INC)

bswapdi2.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/bswapdi2.c' $(CCUOPTS) $(ASUOPTS) $(INC)

bswapsi2.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/bswapsi2.c' $(CCUOPTS) $(ASUOPTS) $(INC)

clzdi2.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/clzdi2.c' $(CCUOPTS) $(ASUOPTS) $(INC)

clzsi2.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/clzsi2.c' $(CCUOPTS) $(ASUOPTS) $(INC)

cmpdi2.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/cmpdi2.c' $(CCUOPTS) $(ASUOPTS) $(INC)

comparedf2.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/comparedf2.c' $(CCUOPTS) $(ASUOPTS) $(INC)

comparesf2.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/comparesf2.c' $(CCUOPTS) $(ASUOPTS) $(INC)

ctzdi2.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/ctzdi2.c' $(CCUOPTS) $(ASUOPTS) $(INC)

ctzsi2.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/ctzsi2.c' $(CCUOPTS) $(ASUOPTS) $(INC)

divdc3.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/divdc3.c' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_ddiv.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_ddiv.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_slldiv.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_slldiv.S' $(CCUOPTS) $(ASUOPTS) $(INC)

divmoddi4.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/divmoddi4.c' $(CCUOPTS) $(ASUOPTS) $(INC)

divmodsi4.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/divmodsi4.c' $(CCUOPTS) $(ASUOPTS) $(INC)

divsc3.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/divsc3.c' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_fdiv.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_fdiv.S' $(CCUOPTS) $(ASUOPTS) $(INC)

REL_f_inf.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/REL_f_inf.S' $(CCUOPTS) $(ASUOPTS) $(INC)

REL_f_norm.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/REL_f_norm.S' $(CCUOPTS) $(ASUOPTS) $(INC)

REL_f_round.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/REL_f_round.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_sldiv.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_sldiv.S' $(CCUOPTS) $(ASUOPTS) $(INC)

extendhfsf2.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/extendhfsf2.c' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_ftod.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_ftod.S' $(CCUOPTS) $(ASUOPTS) $(INC)

ffsdi2.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/ffsdi2.c' $(CCUOPTS) $(ASUOPTS) $(INC)

ffssi2.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/ffssi2.c' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_dtosll.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_dtosll.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_dtosl.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_dtosl.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_ftosll.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_ftosll.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_ftosl.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_ftosl.S' $(CCUOPTS) $(ASUOPTS) $(INC)

REL_dtoll.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/REL_dtoll.S' $(CCUOPTS) $(ASUOPTS) $(INC)

REL_dtol.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/REL_dtol.S' $(CCUOPTS) $(ASUOPTS) $(INC)

REL_ftol.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/REL_ftol.S' $(CCUOPTS) $(ASUOPTS) $(INC)

REL_ftoll.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/REL_ftoll.S' $(CCUOPTS) $(ASUOPTS) $(INC)

REL_lltosll.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/REL_lltosll.S' $(CCUOPTS) $(ASUOPTS) $(INC)

REL_ltosl.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/REL_ltosl.S' $(CCUOPTS) $(ASUOPTS) $(INC)

REL_llrev.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/REL_llrev.S' $(CCUOPTS) $(ASUOPTS) $(INC)

REL_lltof.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/REL_lltof.S' $(CCUOPTS) $(ASUOPTS) $(INC)

REL_ltod.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/REL_ltod.S' $(CCUOPTS) $(ASUOPTS) $(INC)

REL_ltof.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/REL_ltof.S' $(CCUOPTS) $(ASUOPTS) $(INC)

REL_setexp_ll.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/REL_setexp_ll.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_dtoull.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_dtoull.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_dtoul.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_dtoul.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_ftoull.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_ftoull.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_ftoul.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_ftoul.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_slltod.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_slltod.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_slltof.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_slltof.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_sltod.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_sltod.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_sltof.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_sltof.S' $(CCUOPTS) $(ASUOPTS) $(INC)

floattidf.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/floattidf.c' $(CCUOPTS) $(ASUOPTS) $(INC)

floattisf.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/floattisf.c' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_ulltod.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_ulltod.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_ulltof.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_ulltof.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_ultod.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_ultod.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_ultof.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_ultof.S' $(CCUOPTS) $(ASUOPTS) $(INC)

REL_d_round.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/REL_d_round.S' $(CCUOPTS) $(ASUOPTS) $(INC)

REL_lltod.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/REL_lltod.S' $(CCUOPTS) $(ASUOPTS) $(INC)

floatuntidf.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/floatuntidf.c' $(CCUOPTS) $(ASUOPTS) $(INC)

floatuntisf.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/floatuntisf.c' $(CCUOPTS) $(ASUOPTS) $(INC)

fp_mode.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/fp_mode.c' $(CCUOPTS) $(ASUOPTS) $(INC)

int_util.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/int_util.c' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_sllrem.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_sllrem.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_slrem.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_slrem.S' $(CCUOPTS) $(ASUOPTS) $(INC)

muldc3.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/muldc3.c' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_dmul.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_dmul.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_llmul.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_llmul.S' $(CCUOPTS) $(ASUOPTS) $(INC)

REL_llmul_addh.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/REL_llmul_addh.S' $(CCUOPTS) $(ASUOPTS) $(INC)

mulodi4.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/mulodi4.c' $(CCUOPTS) $(ASUOPTS) $(INC)

mulosi4.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/mulosi4.c' $(CCUOPTS) $(ASUOPTS) $(INC)

mulsc3.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/mulsc3.c' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_fmul.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_fmul.S' $(CCUOPTS) $(ASUOPTS) $(INC)

mulvdi3.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/mulvdi3.c' $(CCUOPTS) $(ASUOPTS) $(INC)

mulvsi3.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/mulvsi3.c' $(CCUOPTS) $(ASUOPTS) $(INC)

negdf2.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/negdf2.c' $(CCUOPTS) $(ASUOPTS) $(INC)

negdi2.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/negdi2.c' $(CCUOPTS) $(ASUOPTS) $(INC)

negsf2.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/negsf2.c' $(CCUOPTS) $(ASUOPTS) $(INC)

negvdi2.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/negvdi2.c' $(CCUOPTS) $(ASUOPTS) $(INC)

negvsi2.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/negvsi2.c' $(CCUOPTS) $(ASUOPTS) $(INC)

paritydi2.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/paritydi2.c' $(CCUOPTS) $(ASUOPTS) $(INC)

paritysi2.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/paritysi2.c' $(CCUOPTS) $(ASUOPTS) $(INC)

popcountdi2.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/popcountdi2.c' $(CCUOPTS) $(ASUOPTS) $(INC)

popcountsi2.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/popcountsi2.c' $(CCUOPTS) $(ASUOPTS) $(INC)

powidf2.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/powidf2.c' $(CCUOPTS) $(ASUOPTS) $(INC)

powisf2.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/powisf2.c' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_dsub.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_dsub.S' $(CCUOPTS) $(ASUOPTS) $(INC)

subvdi3.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/subvdi3.c' $(CCUOPTS) $(ASUOPTS) $(INC)

subvsi3.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/subvsi3.c' $(CCUOPTS) $(ASUOPTS) $(INC)

trampoline_setup.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/trampoline_setup.c' $(CCUOPTS) $(ASUOPTS) $(INC)

truncdfhf2.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/truncdfhf2.c' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_dtof.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_dtof.S' $(CCUOPTS) $(ASUOPTS) $(INC)

truncsfhf2.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/truncsfhf2.c' $(CCUOPTS) $(ASUOPTS) $(INC)

ucmpdi2.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/ucmpdi2.c' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_ulldiv.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_ulldiv.S' $(CCUOPTS) $(ASUOPTS) $(INC)

REL_lldiv.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/REL_lldiv.S' $(CCUOPTS) $(ASUOPTS) $(INC)

udivmoddi4.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/udivmoddi4.c' $(CCUOPTS) $(ASUOPTS) $(INC)

udivmodsi4.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/udivmodsi4.c' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_uldiv.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_uldiv.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_ullrem.S.obj:
	@$(CC) $(CCOPTS)  $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_ullrem.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_ulrem.S.obj:
	@$(CC) $(CCOPTS)  $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_ulrem.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_mului.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_mului.S' $(CCUOPTS) $(ASUOPTS) $(INC)

REL_llrem.S.obj:
	@$(CC) $(CCOPTS)  $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/REL_llrem.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_sidiv.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_sidiv.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_imul.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_imul.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_lmul.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_lmul.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_uidiv.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_uidiv.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_scdiv.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_scdiv.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_ucdiv.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_ucdiv.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_divul.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_divul.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_divui.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_divui.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_macsi.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_macsi.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_macui.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_macui.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_mulsi.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_mulsi.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_mulsl.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_mulsl.S' $(CCUOPTS) $(ASUOPTS) $(INC)
	
COM_mulul.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_mulul.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_screm.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_screm.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_ucrem.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_ucrem.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_remui.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_remui.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_remul.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_remul.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_uirem.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_uirem.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_sirem.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_sirem.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_lshl.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_lshl.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_lshr.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_lshr.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_lsar.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_lsar.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_llsar.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_llsar.S' $(CCUOPTS) $(ASUOPTS) $(INC)
	
ashlhi3.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/ashlhi3.S' $(CCUOPTS) $(ASUOPTS) $(INC)
	
ashlqi3.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/ashlqi3.S' $(CCUOPTS) $(ASUOPTS) $(INC)
	
COM_llshr.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_llshr.S' $(CCUOPTS) $(ASUOPTS) $(INC)
	
ashrhi3.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/ashrhi3.S' $(CCUOPTS) $(ASUOPTS) $(INC)
	
ashrqi3.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/ashrqi3.S' $(CCUOPTS) $(ASUOPTS) $(INC)
	
hi_min_max.c.obj:
	@$(CC) $(CCOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/hi_min_max.c' $(CCUOPTS) $(ASUOPTS) $(INC)
	
COM_llshl.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_llshl.S' $(CCUOPTS) $(ASUOPTS) $(INC)
	
lshrhi3.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/lshrhi3.S' $(CCUOPTS) $(ASUOPTS) $(INC)
	
lshrqi3.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/lshrqi3.S' $(CCUOPTS) $(ASUOPTS) $(INC)
	
rotlhi3.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/rotlhi3.S' $(CCUOPTS) $(ASUOPTS) $(INC)
	
rotlqi3.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/rotlqi3.S' $(CCUOPTS) $(ASUOPTS) $(INC)
	
rotrhi3.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/rotrhi3.S' $(CCUOPTS) $(ASUOPTS) $(INC)
	
rotrqi3.S.obj:
	@$(CC) $(CCOPTS) $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/rotrqi3.S' $(CCUOPTS) $(ASUOPTS) $(INC)

REL_dcmp.S.obj:
	@$(CC) $(CCOPTS)  $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/REL_dcmp.S' $(CCUOPTS) $(ASUOPTS) $(INC)

REL_dordered_core.S.obj:
	@$(CC) $(CCOPTS)  $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/REL_dordered_core.S' $(CCUOPTS) $(ASUOPTS) $(INC)

REL_fcmp.S.obj:
	@$(CC) $(CCOPTS)  $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/REL_fcmp.S' $(CCUOPTS) $(ASUOPTS) $(INC)

REL_fordered_core.S.obj:
	@$(CC) $(CCOPTS)  $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/REL_fordered_core.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_deq.S.obj:
	@$(CC) $(CCOPTS)  $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_deq.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_dge.S.obj:
	@$(CC) $(CCOPTS)  $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_dge.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_dgt.S.obj:
	@$(CC) $(CCOPTS)  $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_dgt.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_dle.S.obj:
	@$(CC) $(CCOPTS)  $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_dle.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_dlt.S.obj:
	@$(CC) $(CCOPTS)  $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_dlt.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_dne.S.obj:
	@$(CC) $(CCOPTS)  $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_dne.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_dunordered.S.obj:
	@$(CC) $(CCOPTS)  $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_dunordered.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_feq.S.obj:
	@$(CC) $(CCOPTS)  $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_feq.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_fge.S.obj:
	@$(CC) $(CCOPTS)  $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_fge.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_fgt.S.obj:
	@$(CC) $(CCOPTS)  $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_fgt.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_fle.S.obj:
	@$(CC) $(CCOPTS)  $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_fle.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_flt.S.obj:
	@$(CC) $(CCOPTS)  $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_flt.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_fne.S.obj:
	@$(CC) $(CCOPTS)  $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_fne.S' $(CCUOPTS) $(ASUOPTS) $(INC)

COM_funordered.S.obj:
	@$(CC) $(CCOPTS)  $(ASOPTS) $(FLAGS1) -o $@ -c '$(SRCDIR)/builtins/rl78/COM_funordered.S' $(CCUOPTS) $(ASUOPTS) $(INC)

complete: all rl78
lib: complete $(patsubst lib,,$(MAKECMDGOALS))
	@$(AR) $(AR_SW) '$(LIBPATH)' *.obj
